#include <assigner.hpp>
#include <boost/numeric/ublas/vector.hpp>
#include <boost/numeric/ublas/vector_proxy.hpp>
#include <boost/numeric/ublas/vector_sparse.hpp>
#include <boost/numeric/ublas/matrix_sparse.hpp>
#include <boost/numeric/ublas/io.hpp>
#include <boost/numeric/ublas/matrix.hpp>

using namespace boost::numeric::ublas;

int main(int argc, char *argv[]) {

    vector<double> a(10), b(4,-10.0);
    a<< 0, 0, 1, 2, 3, 4, b;
    std::cout << a << std::endl;

    bounded_vector<double, 3> bv;
    bv<< 0, 1, 2;
    std::cout << bv << std::endl;

    vector_range<vector<double> > vr (a, range (0, 3));
    vr << 11.0, 11.0, 12.0;
    std::cout << a << std::endl;

    mapped_vector<double> mv (10, 10);
    mv << 10, 9, 8, non_vector(3), 2;
    std::cout << mv << std::endl;

    compressed_vector<double> cv (10, 10);
    cv << 10, 9, 8, non_vector(3), 2;
    std::cout << cv << std::endl;

    coordinate_vector<double> cov (10, 10);
    cov << 10, 9, 8, non_vector(3), 2, non_vector(2), 1;
    std::cout << cov << std::endl;

    vector<double> c(42, 0);
    c << non_vector(2), a, non_vector(10), cov;
    std::cout << c << std::endl;

    matrix<double, column_major> m1(3,4);
    m1 << 1, 2, 3, 4, project(a, range(0,4)),b;
    std::cout << m1 << std::endl;

    matrix<double> m2(3,4, 111);
    m2 << non_vector(4),0, project(b,range(0,2)), non_vector(4),2;
    std::cout << m2 << std::endl;

    matrix<double> m3(3,4, 0);
    m3 << a,non_vector(1),22;
    std::cout << m3 << std::endl;

    mapped_matrix<double> mm(3,4, 3*4);
    mm << non_vector(4),1, project(b,range(0,2)), non_vector(4),2;
    std::cout << mm << std::endl;

    compressed_matrix<double> cm(3,4, 3*4);
    cm << non_vector(4),1, project(b,range(0,2)), non_vector(4),2;
    std::cout << cm << std::endl;

    coordinate_matrix<double> com(4,3, 4*3);
    com << non_vector(3),1, project(b,range(0,2)), non_vector(5),2;
    std::cout << com << std::endl;

    return 0;
}

